/*
 *
 * Interfaces.h - interfaces declarations
 *
 * Date:	19.9.2004 
 * Author:	Jiri Formanek
 *
 */
#pragma once

enum TERRAIN_METHOD
{
	TM_HEIGHTMAP = 0,
	TM_CIRCLE
};

class ENGINE_API ITerrain
{
public:
	virtual HRESULT			GenerateTerrain(int x, int y, TERRAIN_METHOD tmMethod = TM_CIRCLE)  = 0;	
	virtual HRESULT			GenerateTerrainFromFile(LPCSTR szFile)  = 0;	
	virtual HRESULT			DestroyTerrain()  = 0;	
	virtual int				GetTitlesX()  = 0;	
	virtual int				GetTitlesY()  = 0;	
	virtual float			GetTerrainHeignt(int x, int y)  = 0;	
	virtual void			IncreaseLODLevel()  = 0;	
	virtual void			DecreaseLODLevel()  = 0;	

	virtual void			SetFlag(DWORD dwFlag)  = 0;	
	virtual void			UnsetFlag(DWORD dwFlag)  = 0;	
	virtual void			InvertFlag(DWORD dwFlag)  = 0;	
	virtual void			ResetFlags()  = 0;	

	virtual HRESULT			Render() = 0;	
	virtual HRESULT			Restore() = 0;	

public:	
	// interface functions
	virtual HRESULT		AddRef() = 0;
	virtual HRESULT		Release() = 0;
};
