/*
 *
 * Manager.cpp - Implementation of manager
 * Date:	19.9.2004
 * Author:	Jiri Formanek
 *
 */
#include "StdAfx.h"
#define ENGINE_API __declspec(dllexport)

#include "Interfaces.h"

#include "../Common/Common.h"
#include "../Display/Common.h"
#include "../Input/Common.h"

#include "Manager.h"
#include "Terrain.h"

// Call This function to get desired interface
ENGINE_API  HRESULT	CreateEngineObject(ENGIID InterfaceID, void ** ppv)
{
	// unique objects
	static ITerrain		* g_theTerrain = NULL;	
	if(!ppv)
	{
		return ERROR_INVALID_PARAMETER;
	}
	// get pointer according IID 
	switch(InterfaceID) {
		case ENGIID_ITerrain:
			if(!g_theTerrain) 
			{
				*ppv = g_theTerrain = new CTerrain;
			}
			else {
				*ppv = g_theTerrain;
			}
			((ITerrain*)(*ppv))->AddRef();
			break;		
		default:
			return E_NOINTERFACE;
	}
	return S_OK;
}